import string




#default values of portal variables

portal_vars={
'bk_color':['#99aaff','bkg color'],
'time_format':['%m/%d/%Y  - %I:%M%p','time format'],
'portal_title':['#aabbff','color of portal title'],
#dialog boxes
'n_rows':[5,'n rows'],
'n_cols':[30,'n cols'],
'n_size':[30,'input size'],
#navtable
'c_border':['#000000','border'],
'c_title':['#336699','title'],
'c_body':['#bbbbff','body'],

#css values
#default link
'd_link':['blue','link'],
'd_hover':['red','hover'],

#title map
'tmap':['white','link'],
'tmaph':['black','hover'],

#normal link
'map':['black','link'],
'maph':['red','hover'],

#not approved
'xmap':['red','link'],
'xmaph':['white','hover'],

#not published (waiting for approve)
'nmap':['green','link'],
'nmaph':['red','hover'],

#hidden link
'hmap':['#bbccff','link'],
'hmaph':['red','hover']

}



#set prop in home folder
def manage_add_vars(self):
 for i in portal_vars.items():
   self.manage_addProperty(i[0],str(i[1][0]),'string')



#return edit style variable form
def edit_style(request):
 PARENTS=request['PARENTS']
 ret='''<dtml-if edit_item>
 <dtml-with "PARENTS[0]">
'''
 ret=ret+'''
   <dtml-call "manage_changeProperties({'title':item_title})">
   <dtml-call "manage_changeProperties({'description':item_descr})">
'''
 for i in portal_vars.items():
     ret=ret+'   <dtml-call "manage_changeProperties({\''+i[0]+'\':new_'+i[0]+'})">'
     ret=ret+'''
'''

 ret=ret+'''
 </dtml-with>
 <dtml-call "RESPONSE.redirect(HTTP_REFERER)">

 
<dtml-else>
<dtml-var standard_html_header>
<h1>Edit Style</h1>
<form method="post">
<table border=0>
<tr><th></th><td>
 <input type="submit" name="edit_item" value=" change ">
 <input type="button" value=" cancel " onclick="JavaScript:location.href=('<dtml-var HTTP_REFERER>');">
</td></tr>
<tr><td><b>title</b></td><td><input type="text" name="item_title" size="<dtml-var "scripts(PARENTS).get_portalvar(PARENTS,'n_size')">" value="<dtml-var title>"></td></tr>
<tr><td valign="top"><b>description</b></td><td><textarea name="item_descr" rows="<dtml-var "scripts(PARENTS).get_portalvar(PARENTS,'n_rows')">" cols="<dtml-var "scripts(PARENTS).get_portalvar(PARENTS,'n_cols')">"><dtml-var description></textarea></td></tr>

'''


 descr=['general settings','dialog text sizes','navigation table colors',
  'default links','navtable colors (normal item=published)','item not approved (publish denied)','item not published (waiting for approve)','item is hidden (owner want this)']

 lista=[
 ['bk_color','time_format','portal_title'],
 ['n_rows','n_cols','n_size'],
 ['c_border','c_title','c_body'],
 ['d_link','d_hover'],
 ['tmap','tmaph','map','maph'],
 ['xmap','xmaph'],
 ['nmap','nmaph'],
 ['hmap','hmaph']
  ]
        
 ix=0
 for lll in lista:
   ret=ret+'<tr><td></td><td><b>'+descr[ix]+'</b></td><td></td></tr>'
   ix=ix+1
   for i in lll:
     ret=ret+'<tr><td><b>'+portal_vars[i][1]+'</b></td><td><input type="text" name="new_'+i+'" value="<dtml-var '+i+'>" size="30"></td></tr>'
     ret=ret+'''
'''



 ret=ret+'''
<tr><th></th><td>
 <input type="submit" name="edit_item" value=" change ">
 <input type="button" value=" cancel " onclick="JavaScript:location.href=('<dtml-var HTTP_REFERER>');">
</td></tr>
</table>
</dtml-if>'''
 return ret
 



#return a variable self.property or default
def get_portalvar(PARENTS,varname):
 #PARENTS=request['PARENTS']
 self=PARENTS[0]
 ob=getPortalRoot(PARENTS).styles
 value=portal_vars[varname][0]
 if self.REQUEST.cookies.has_key('portal_style'):
  try:
   value=ob[self.REQUEST.cookies['portal_style']].getProperty(varname)
  except:
   pass
 return value






#****************************************************************************


#return root object
def getPortalRoot(PARENTS):
 o=PARENTS[0]
 for i in PARENTS:
  if i.hasProperty('portal'):
    o=i
    break
 return o


#****************************************************************************

#return products folder object
def products(PARENTS):
 return getPortalRoot(PARENTS).sec.Products

#****************************************************************************


#return scripts folder object
def scripts(PARENTS):
 return getPortalRoot(PARENTS).sec.methods


#****************************************************************************
#recursive return news
def ret_news(o):
    ret=[]
    for i in o.objectItems(['Folder','DTML Document']):
        o=i[1] #the object
        id=i[0]
        title=o.title
        try:
            if o.itemtype=='folder': ret=ret+ret_news(o)
            if o.itemtype=='news':
                if int(o.published)==2: ret.append(o)
        except:
            pass
    return ret



#****************************************************************************


#sort news
def sort_news_cmp_func(o1,o2):
    t1=int(o1.bobobase_modification_time())
    t2=int(o2.bobobase_modification_time())
    if t1<t2: return -1
    if t1>t2: return 1
    if t1==t2 : return 0


#table with news items
def list_news(PARENTS,n,title):
    #PARENTS - list of parents
    #n=number of news items to list
    # =0 to list all news
    root=getPortalRoot(PARENTS)

    c_border=get_portalvar(PARENTS,'c_border')
    c_title=get_portalvar(PARENTS,'c_title')
    c_body=get_portalvar(PARENTS,'c_body')

    lista = ret_news(root)
    lista.sort(sort_news_cmp_func)
    lista.reverse()

    ret='<!-- news table -->'
    ret=ret+'<table border="0" cellspacing="0" cellpadding="1" bgcolor="'+c_border+'+"><tr><td>'
    ret=ret+'<table width="100%" border="0" cellspacing="1" cellpadding="3">'
    ret=ret+'<tr><td bgcolor="'+c_title+'">'+title+'</td></tr>'
    ret=ret+'<tr><td bgcolor="'+c_body+'">'
    ix=0
    for o in lista:
        ix=ix+1
        if n>0 and ix>n: break
        ret=ret+'<nobr><a href="'+o.absolute_url()+'/view"'
        if o.published=='0': link_class=' class="nmap"' #waiting to be approved
        if o.published=='1': link_class=' class="xmap"' #not approved
        if o.published=='2': link_class=''              #is approved - no class
        if o.published=='3': link_class=' class="hmap"' #hidden
        ret=ret+link_class+'>'
        ret=ret+'<img border=0 height=16 width=16 alt="'+o.itemtype+'" src="'
        ret=ret+products(PARENTS).absolute_url()+'/'+o.itemtype+'/itemicon'+'"> '
        ret=ret+'<b>'+str(o.bobobase_modification_time().strftime(get_portalvar(PARENTS,'time_format')))+' '
        ret=ret+o.user+' :</b> '+o.title_or_id()+'</a></nobr><br>'
    
    ret=ret+'</td></tr></table></td></tr></table><br>'
    return ret


#****************************************************************************
#table with manage links for current item
def managetable(self,root,PARENTS,f=1):
 #
 #self =the object
 #root =the portal root object
 #items=a list with zope items
 #f    =1 for table with width=100%
 #

 c_border=get_portalvar(PARENTS,'c_border')
 c_title=get_portalvar(PARENTS,'c_title')
 c_body=get_portalvar(PARENTS,'c_body')


 base=root.absolute_url()
 default_icon=root.help.icon

 if self.REQUEST.AUTHENTICATED_USER.getUserName()=='Anonymous User':
  t='Guest'
  a=root.help.absolute_url()
 else:
  t=self.REQUEST.AUTHENTICATED_USER.getUserName()
  a=root.Members.absolute_url()+'/'+t

 ret='<!-- manage table -->'
 ret=ret+'<table'
 if f==1: ret=ret+' width="100%"'
 ret=ret+' border="0" cellspacing="0" cellpadding="1" bgcolor="'+c_border+'+"><tr><td>'
 ret=ret+'<table width="100%" border="0" cellspacing="1" cellpadding="3">'
 ret=ret+'<tr><td bgcolor="'+c_title+'">'
 ret=ret+'<img src="'+base+'/img/user.gif" border=0> '
 ret=ret+'<a href="'+a+'" class="tmap">'+t+'</a></td></tr>'
 ret=ret+'<tr><td bgcolor="'+c_body+'">'

 ret=ret+'<img border=0 height=16 width=16 alt="Search this site" src="'+base+'/img/search.gif"> <a href="'+base+'/search" class="map">Search</a><br>'
 ret=ret+'<img border=0 height=16 width=16 alt="Help about this site" src="'+base+'/img/help.gif"> <a href="'+base+'/help" class="map">Help</a><br>'
 
 if self.REQUEST.AUTHENTICATED_USER.getUserName()=='Anonymous User':
  #guest items
  ret=ret+'<img border=0 height=16 width=16 alt="method" src="'+base+'/img/login.gif"> <a href="'+base+'/login" class="map">Login</a><br>'
  ret=ret+'<img border=0 height=16 width=16 alt="method" src="'+base+'/img/user.gif"> <a href="'+base+'/register" class="map">Register</a><br>'
 else:
  #user items
  if self.REQUEST.AUTHENTICATED_USER.has_role('Manager'):
    ret=ret+'<img border=0 height=16 width=16 alt="method" src="'+base+'/img/admin.gif'+'"> <a href="'+base+'/Admin" class="map">Admin</a><br>'
  if can_create(self,PARENTS):
    ret=ret+'<img border=0 height=16 width=16 alt="method" src="'+default_icon+'"> <a href="add" class="map">Add New Item</a><br>'

 ret=ret+'<img border=0 height=16 width=16 alt="method" src="'+default_icon+'"> <a href="selectstyle" class="map">Select Style</a><br>'


 if is_visible(self,PARENTS):
  ret=ret+'<hr>'
  ret=ret+'<img border=0 height=16 width=16 alt="method" src="'+default_icon+'"> <a href="view" class="map">View</a><br>'
  ret=ret+'<img border=0 height=16 width=16 alt="method" src="'+default_icon+'"> <a href="info" class="map">Info</a><br>'
  if self.itemtype=='folder':
    ret=ret+'<img border=0 height=16 width=16 alt="method" src="'+default_icon+'"> <a href="view_subitems" class="map">View Subitems</a><br>'
    ret=ret+'<img border=0 height=16 width=16 alt="method" src="'+default_icon+'"> <a href="all_news" class="map">List All News</a><br>'

  #manage links
  if can_manage(self,PARENTS):
    ret=ret+'<img border=0 height=16 width=16 alt="method" src="'+default_icon+'"> <a href="edit" class="map">Edit</a><br>'
    ret=ret+'<img border=0 height=16 width=16 alt="method" src="'+default_icon+'"> <a href="erase" class="map">Erase</a><br>'


 ret=ret+'</td></tr></table></td></tr></table><br>'

 return ret


#****************************************************************************

#display current position
def path_menu(PARENTS):
 lista=[]
 ret='/'
 for i in PARENTS:
   lista.append(i)
   if i.hasProperty('portal'): break
 lista.reverse()
 for i in lista:
   ret=ret+'<a href="'+i.absolute_url()+'/view">'+i.title_or_id()+'</a>'+'/'
 return ret



#****************************************************************************

#display folders from root
def top_menu(self,PARENTS):
 l=self.objectItems(['Folder'])
 try:
  l.sort()
 except:
  pass
 ret=''
 for i in l:
  o=i[1] #the object
  if is_visible(o,PARENTS) and i[0]!='styles':
    ret=ret+'&nbsp;&nbsp;&nbsp;&nbsp;'
    ret=ret+'<a href="'+o.absolute_url()+'/view"'
    if o.published=='0': link_class=' class="nmap"' #waiting to be approved
    if o.published=='1': link_class=' class="xmap"' #not approved
    if o.published=='2': link_class=''              #is approved - no class
    if o.published=='3': link_class=' class="hmap"' #hidden

    ret=ret+link_class+'>'+o.title_or_id()+'</a>'
 ret=ret+'&nbsp;&nbsp;&nbsp;&nbsp;'
 return ret

#****************************************************************************


#for search - display subdocument
def sub_doc(s,pos,n,search_expr):
 start_ix = int(pos) - int(n)
 if start_ix < 0: start_ix = 0
 end_ix = int(pos) + int(n) + len(search_expr)
 if end_ix > len(s): end_ix = len(s)
 ret = string.replace(s[start_ix:end_ix],'<',' ')
 ret = string.replace(ret,'>',' ')
 return string.replace(string.lower(ret),string.lower(search_expr),'<b><u>'+search_expr+'</u></b>')


#****************************************************************************

#search this site
def site_search(self,PARENTS,search_expr='',cnt=0):
 ret=''
 count=cnt
 for i in self.objectItems(['Folder','ZWiki Page','DTML Document']):
    o=i[1] #the object
    id=i[0]
    title=o.title
    des=''
    if o.hasProperty('descr'): des=o.descr
    if o.hasProperty('description'): des=o.description
    if o.getNodeName()=="Folder":
          ret1,count1=site_search(o,PARENTS,search_expr,count)
          ret=ret+ret1
          count=count1
    else:
         ix1 = string.find(string.lower(o.raw),string.lower(search_expr)) #body
         ix2 = string.find(string.lower(des),string.lower(search_expr))   #description
         ix3 = string.find(string.lower(title),string.lower(search_expr)) #title
         if search_expr=='' or  ix1 != -1 or ix2 != -1 or ix3 != -1 :
           count=count+1
           ret=ret+'<img border=0 height=16 width=16 alt="'+o.itemtype+'" src="'
           ret=ret+self.products(PARENTS).absolute_url()+'/'+o.itemtype+'/itemicon'+'"> '
           ret=ret+'<a href="'+o.absolute_url()+'/view"'
           link_class=''
           if o.published=='0': link_class=' class="nmap"' #waiting to be approved
           if o.published=='1': link_class=' class="xmap"' #not approved
           if o.published=='2': link_class=' class="map"'  #is approved
           if o.published=='3': link_class=' class="hmap"' #hidden
           ret=ret+link_class+'>'+o.title_or_id()+'</a>' # '<b>'+str(o.bobobase_modification_time())+'</b>'
           if search_expr!='':
             ret=ret+'<div style="margin-left:0.5cm; position:relative; text-align : left;">'
             if ix1!=-1: ret=ret+sub_doc(o.raw,ix1,20,search_expr)
             if ix2!=-1: ret=ret+sub_doc(des,ix2,20,search_expr)
             if ix3!=-1: ret=ret+sub_doc(title,ix3,20,search_expr)
             ret=ret+'</div><hr>'
           else: ret=ret+'<br>'
 return ret,count




#****************************************************************************



#list current item  with his manage links
def navtable(self,PARENTS,f=1):
 #
 #self =the object
 #items=a list with zope items
 #f    =1 for table with width=100%
 #


 c_border=get_portalvar(PARENTS,'c_border')
 c_title=get_portalvar(PARENTS,'c_title')
 c_body=get_portalvar(PARENTS,'c_body')


 items=['Image','Folder','DTML Document','File','ZWiki Page']

 table1='<!-- nav table -->'
 table1=table1+'<table'
 if f==1: table1=table1+' width="100%"'
 table1=table1+' border="0" cellspacing="0" cellpadding="1" bgcolor="'+c_border+'+"><tr><td>'
 table1=table1+'<table width="100%" border="0" cellspacing="1" cellpadding="3">'
 table1=table1+'<tr><td bgcolor="'+c_title+'">'
 #table1=table1+'<img border=0 height=16 width=16 src="'+self.icon+'"> '
 table1=table1+'<a href="'+self.absolute_url()+'/view" class="tmap">'+self.title_or_id()+'</a></td></tr>'
 table1=table1+'<tr><td bgcolor="'+c_body+'">'


 table2='</td></tr></table></td></tr></table><br>'


 ret=''

 if self.getNodeName()=='Folder' and is_visible(self,PARENTS):
  lista=self.objectItems(items)
  try:
   lista.sort()
  except:
   pass
  for i in lista:
   o=i[1] #the object
   title=o.title_or_id()
   id=i[0]
   if is_visible(o,PARENTS):
       ret=ret+'<nobr><img border=0 height=16 width=16 alt="'+o.itemtype+'" src="'
       ret=ret+self.products(PARENTS).absolute_url()+'/'+o.itemtype+'/itemicon'
       ret=ret+'"> '
       ret=ret+'<a href="'+o.absolute_url()+'/view"'
       if o.published=='0': link_class=' class="nmap"' #waiting to be approved
       if o.published=='1': link_class=' class="xmap"' #not approved
       if o.published=='2': link_class=' class="map"'  #is approved
       if o.published=='3': link_class=' class="hmap"' #hidden

       ret=ret+link_class+'" >'+title+'</a></nobr><br>'

 if ret=='':  return ret
 else:        return table1+ret+table2



#****************************************************************************




#list all subfolders with items
def local_subitems(self,PARENTS):
 ret='<table><tr>'
 l=self.objectItems(['Folder'])
 try:
  l.sort()
 except:
  pass
 for i in l :
  o=i[1] #the object
  title=o.title_or_id()
  id=i[0]
  if ((title != '' and id != 'index_html') or o.getNodeName()=='ZWikiPage'):
   ret1=navtable(o,PARENTS,0)
   if ret1!='':
    ret=ret+'<td valign="top">'+ret1+'</td>'
 ret=ret+'</tr></table>'
 return ret



#****************************************************************************



#check if user can add items
def can_create(self,PARENTS):
 can=1
 if not is_member(self.getPortalRoot(PARENTS),self.accessgroups) or self.REQUEST.AUTHENTICATED_USER.getUserName()=='Anonymous User':
  can=0
 if self.hasProperty('readonly'):
    if int(self.readonly)==1: can=0
 if self.REQUEST.AUTHENTICATED_USER.getUserName()==self.user or self.REQUEST.AUTHENTICATED_USER.has_role('Manager'):
   can=1
 return can

#****************************************************************************

#test rights for manage item
def can_manage(self,PARENTS):
 access=0
 if self.REQUEST.AUTHENTICATED_USER.getUserName()==self.user or self.REQUEST.AUTHENTICATED_USER.has_role('Manager'):
  access=1
 if is_member(self.getPortalRoot(PARENTS),'Adm'):
  access=1
 if self.hasProperty('system'):
    if int(self.system)==1: access=0
 if self.hasProperty('portal'):
    access=0
 return int(access)


#****************************************************************************

#check if current user is member of groups
def is_member(root,groups):
 user=root.REQUEST.AUTHENTICATED_USER.getUserName()
 gr=['Everyone']
 for i in root.Admin.SQL_ListUsers(name='',username=user):
   gr=string.split('Everyone,'+i.groups,',')
   break
 flag=0
 for i in string.split(groups,','):
   if i in gr:
     flag=1
     break
 return int(flag)

#****************************************************************************

#test if user can see it or not
def is_visible(self,PARENTS):
 ret=0
 if int(self.published)==2:
  ret=1
 if not is_member(self.getPortalRoot(PARENTS),self.accessgroups):
  ret=0
 if is_member(self.getPortalRoot(PARENTS),'Adm') or self.user==self.REQUEST.AUTHENTICATED_USER.getUserName() or self.REQUEST.AUTHENTICATED_USER.has_role('Manager'):
  ret=1
 if self.hasProperty('system'):
    if int(self.system)==1:
       ret=0
 return int(ret)



#****************************************************************************












